
write_def( Name, Defs ) :-
     write_def( Name, Defs, [] ).

write_def( NameOrTerm, Defs, Opts ) :-
     ( atomic(NameOrTerm) ->
          functor( Term, NameOrTerm, 1 ),
          arg( 1, Term, Wable )
          ;
          ( compound(NameOrTerm) ->
               Term = NameOrTerm,
               ( memberchk(write(Wable),Opts) ->
                    true
                    ;
                    ( functor(NameOrTerm,_,1) ->
                         arg( 1, NameOrTerm, Wable )
                         ;
                         Goal = write_def/3, 
                         Who = ' write/1 option should have',
                         Where = ' when Term is no an unary term',
                         throw( error(context_error(Goal,Who),Where) )
                    )
               )
               ;
               Goal = write_def/3, 
               Exp = 'name of unary option or n-ary term option template ',
               Got = NameOrTerm,
               throw( error(type_error(Goal,_,Exp,Got)) )
          )
     ),
     ( memberchk(def_label(DefLbl),Opts) -> true; DefLbl = def ),
     findall( Wable, member(Term,Defs), Wts ),
     ( Wts == [] ->
          ( memberchk(no_def_mess(NoDefMess),Opts) ->
               true
               ;
               NoDefMess = 'no def'
          ),
          ( memberchk(limit(Lim),Opts) ->
               ( memberchk(offset(Offset),Opts) -> true; Offset is 0 ),
               write_with_limit_and_offset(['(' , NoDefMess, ')'],Lim,Offset)
               ;
               write( '(' ),
               write( NoDefMess ),
               write( ')' )
          )
          ;
          ( memberchk(limit(Lim),Opts) ->
               ( memberchk(offset(Offset),Opts) -> true; Offset is 0 ),
               append( ['(',DefLbl,':'], Wts, DefLblVal ),
               append( DefLblVal, [')'], DefPrint ),
               write_with_limit_and_offset( DefPrint, Lim, Offset )
               ;
               (Wts = [Sgl] -> DefVal = Sgl ; DefVal = Wts),
               write( ' (' ),
               write( DefLbl ),
               write( ':' ),
               write( DefVal ),
               write( ')' )
          )
     ),
     ( memberchk(dot,Opts) -> write( '.' ); true ).

write_with_limit_and_offset( List, Lim, Offset ) :-
     would_print( List, 0, Length ),
     % write( lgt(Length)-lim(Lim)-offset(Offset) ), nl,
     ( Length > Lim -> 
          nl, spcs( Offset )
          ;
          true
     ),
     write_list_here( List ).

write_list_here( [] ).
write_list_here( [H|T] ) :-
     write( H ),
     write_list_here( T ).

would_print( [], Length, Length ).
would_print( [H|T], Acc, Length ) :-
     ( atom(H) ->
          atom_codes( H, HCs )
          ;
          ( number(H) ->
               number_codes( H, HCs )
               ;    % we assume compound then ?
               write_to_chars( H, HCs )
          )
     ),
     length( HCs, Hlength ),
     Nxt is Acc + Hlength,
     would_print( T, Nxt, Length ).
